#include <QtTest>
#include "tst_unittest_motorcontroller.h"

void TestMotorController::initTestCase()
{
    // Initialisierungslogik, falls erforderlich
}

void TestMotorController::cleanupTestCase()
{
    // Bereinigungslogik, falls erforderlich
}

void TestMotorController::init()
{
    motor = new Elektromotor();
    controller = new MotorController(*motor);
}

void TestMotorController::cleanup()
{
    delete controller;
    delete motor;
}

void TestMotorController::testStarteMotorMitGeschwindigkeit()
{
    controller->starteMotorMitGeschwindigkeit(5);
    QCOMPARE(motor->getGeschwindigkeit(), 5); // Überprüfen, ob die Geschwindigkeit korrekt gesetzt ist
}

void TestMotorController::testStoppeMotor()
{
    controller->starteMotorMitGeschwindigkeit(5);
    controller->stoppeMotor();
    QCOMPARE(motor->getGeschwindigkeit(), 0); // Überprüfen, ob die Geschwindigkeit auf 0 gesetzt wurde
}

void TestMotorController::testFahreZuPosition()
{
    int neuePosition = 10;
    controller->fahreZuPosition(neuePosition);
    QCOMPARE(motor->getPosition(), neuePosition); // Überprüfen, ob die Position korrekt gesetzt wurde
}

void TestMotorController::testStatusAnzeige()
{
    // Da die statusAnzeige()-Methode nur die aktuelle Position und Geschwindigkeit auf die Konsole ausgibt,
    // könnte man hier die Ausgabe überprüfen oder die Methode anpassen, um überprüfbare Zustände zurückzugeben.
    // Hier wird jedoch nur die Methode aufgerufen, um sicherzustellen, dass sie fehlerfrei ausgeführt wird.
    controller->statusAnzeige();
    // Es gibt keine direkte Möglichkeit, die Konsolenausgabe zu testen, daher keine QCOMPARE-Anweisung hier.
}

QTEST_MAIN(TestMotorController)
