#include "tst_paymentprocessor.h"

void PaymentProcessorTest::initTestCase()
{
}

void PaymentProcessorTest::cleanupTestCase()
{
}

void PaymentProcessorTest::init()
{

    Zubereitung* zubereitung = new Zubereitung(Tonkotsu, Soy); // Assuming a default constructor
    processor = new PaymentProcessor(zubereitung);
}

void PaymentProcessorTest::cleanup()
{
    delete processor;
}

void PaymentProcessorTest::testGetTotalAmount()
{
    QCOMPARE(processor->getTotalAmount(), 0.0);
}

void PaymentProcessorTest::testSetTotalAmount()
{
    processor->setTotalAmount(100.0);
    QCOMPARE(processor->getTotalAmount(), 100.0);
}

void PaymentProcessorTest::testProcessCardPayment()
{
    processor->setTotalAmount(50.0);
    QSignalSpy spy(processor, &PaymentProcessor::paymentSuccessful);
    processor->processCardPayment();
    QCOMPARE(processor->getPaidAmount(), 50.0);
    QCOMPARE(spy.count(), 1);
}

void PaymentProcessorTest::testProcessCashPayment()
{
    processor->setTotalAmount(30.0);
    QSignalSpy spy(processor, &PaymentProcessor::paymentSuccessful);
    processor->processCashPayment(20.0);
    QCOMPARE(processor->getPaidAmount(), 20.0);
    QCOMPARE(spy.count(), 0);

    processor->processCashPayment(10.0);
    QCOMPARE(processor->getPaidAmount(), 30.0);
    QCOMPARE(spy.count(), 1);
}

void PaymentProcessorTest::testReset()
{
    processor->setTotalAmount(100.0);
    processor->processCashPayment(50.0);
    processor->reset();
    QCOMPARE(processor->getTotalAmount(), 0.0);
    QCOMPARE(processor->getPaidAmount(), 0.0);
}

void PaymentProcessorTest::testClearCashBalance()
{
    processor->setTotalAmount(50.0);
    processor->processCashPayment(50.0);
    processor->clearCashBalance();
    QCOMPARE(processor->getCashBalance(), 0.0);
}

QTEST_MAIN(PaymentProcessorTest)
//#include "tst_paymentprocessor.moc"
